% Syngas bubble column simulation - Jacobian sparsity matrix calculation
% Published in BMC Systems Biology
% Written by Jin Chen and Michael A. Henson
% December, 2015

function Jac = syngas_bubblecolumn5_jac(N,ns)

Jac(1:2*ns,:) = [ones(2*ns,4*ns) zeros(2*ns,(N-3)*ns)];
for i=3:N
    Jac((i-1)*ns+1:(i-1)*ns+ns,:) = [zeros(ns,(i-3)*ns) ones(ns,4*ns) zeros(ns,(N-i)*ns)];
end
Jac(N*ns+1:N*ns+ns,:) = [zeros(ns,(N-3)*ns) ones(ns,4*ns)];

Jac=[Jac; zeros(1,size(Jac,2))];
Jac=[Jac zeros(size(Jac,1),1)];
    

